#define KEYB_MAX 16

#define KB_NOTHING 0
#define KB_KEYDOWN 1
#define KB_KEYUP 2
#define KB_ASCII 3
#define KB_KEYPRESS KB_ASCII

#define KBSC_UP 72
#define KBSC_LEFT 75
#define KBSC_RIGHT 77
#define KBSC_DOWN 80
#define KBSC_ENTER 28
#define KBSC_SPACE 57
#define KBSC_TAB 15

void *keybs[KEYB_MAX];

void keyb_callbackfunction()
    {
    unsigned rax,rbx;
    char x[2];
    int i;

    _asm
        {
        push ax
        mov ax, SEG mousex
        mov ds, ax
        pop ax

        mov rax, ax
        mov rbx, bx
        }
    if(!rax) return;
    for(i=0;i<TASKS_MAX;i++)
        if(tasks[i].msgstat & MS_WANTKEYBMSG)
            sendmessage(0,i,MSG_GENERICKEYB,rax,rbx,0);
    wm_keyb(rax,rbx);
    if(rax == 3)
        {
        if(rbx == 27)
            sendmessage(0,0,MSG_KILL,0,0,0);
        else if(rbx == 'r')
            sendmessage(0,0,MSG_FLASH,65,0,0);
        }
/*    if(rax == KB_KEYUP)    _asm
            {
            mov ah, 0eh
            mov al, 7
            mov bl, 0fh
            int 10h
            }  */
    }

void keyb_look()
    {
    int i;
    int kbcntr=0;
    void *kbptr;
    for(i=0;i<KEYB_MAX;i++) keybs[i] = NULL;
    for(i=0;i<DRIVER_MAX;i++)
        if(drvlist[i].used)
            if(drvlist[i].dtyp == DTYP_KEYBOARD)
                {
                keybs[kbcntr++] = kbptr = drvlist[i].drvcall;
                _asm
                    {
                    mov ax, SEG keyb_callbackfunction
                    mov es, ax
                    mov si, OFFSET keyb_callbackfunction
                    mov ax, 0700h
                    push ds
                    call kbptr
                    pop ds
                    cmp ax, 0x8000
                    jb keybok
                    }
                keybs[--kbcntr] = NULL;
                keybok:;
//                putch(7);
                }
    }
