CPU 286
ORG -3

%include "const.inc"

    db '->'     ; Begin
    db 0        ; Flags

;-------------------------------------------------

        mov ax, cs
        mov ds, ax
        mov [storcs], ax
        mov [storcs2], ax

        mov ax, 26h
        int 0F0h
        mov [myself], bx

        mov ax, 1016h       ; Create window
        mov si, wndstruct
        int 0F0h

        mov [wnd], ax

        mov ax, 5           ; fopen
        mov bx, inifile
        xor cx, cx
        int 0F0h
        cmp ax, 8000h
        jb fook

        mov ax, 38h         ; ini error
        mov si, errini
        int 0F0h

        xor ax, ax          ; error
        int 0F0h

        fook:
        push cs
        pop ds
        mov [fhnd], ax      ; store filehandle

        nextentry:
        call readint
        cmp ax, 0FFFFh
        jz donini
        push ax
        call readint
        push ax

        mov ax, 39h         ; read line into new buffer
        mov di, sombuf
        mov cx, [fhnd]
        mov dx, 150
        int 0F0h
        mov ax, es
        mov [cs:newl], ax

        mov ax, 20h         ; get until -END-
        mov bx, sombuf
        mov cx, [cs:fhnd]
        int 0F0h

        push cs
        pop ds
        mov ax, [newl]
        mov es, ax
        mov ax, 2014h       ; create sprite with lbl
        mov dx, [wnd]
        pop cx
        pop bx
        mov si, sombuf
        xor di, di
        int 0F0h
        push bx

        mov cx, ax
        mov ax, 2011h       ; set tag
        mov bx, [cs:newl]
        mov dx, bx
        int 0F0h

        pop cx
        mov ax, 2011h       ; set tag
        mov bx, [cs:newl]
        mov dx, bx
        int 0F0h

        jmp nextentry
        donini:

mainloop:
        push cs
        pop ds
        mov ax, 10h
        int 0f0h
        mov ax, 2000h
        int 0f0h

        cmp dx, MSG_CLICK
        jnz mainloop
        cmp si, [wnd]
        jnz mainloop

        mov ax, 2010h       ; get tag
        mov cx, di
        int 0F0h
        mov ds, bx
        xor bx, bx
        xor dx, dx
        mov al, [0]
        cmp al, 0
        jz quitme
        mov ax, 1           ; exec
        int 0F0h
        cmp ax, 8000h
        jb mainloop
        mov cx, ax          ; err2str
        mov ax, 0bh
        int 0F0h
        mov si, bx
        mov ax, 38h         ; msgbox
        int 0F0h
        jmp mainloop
quitme:
        xor ax, ax
        int 0F0h
readint:
        mov ax, 7           ; readline
        mov cx, [fhnd]
        mov dx, 150
        mov bx, sombuf
        int 0F0h
        mov ax, 2           ; strtoint
        int 0F0h
        ret


newl:       dw 0
wnd:        dw 0
fhnd:       dw 0
sombuf:
wndstruct:
myself:     dw 0xFFFF
            dw 32+64+8      ; Flags: WF_TITLE + WF_ICON_SPRITE + WF_FILL
            dw 0,0,0,0      ; x,y,w,h
            dw 0,0          ; wprg
            dw titl         ; title OFF
storcs:     dw 0            ; title SEG
            dw icon
storcs2:    dw 0            ; icon
            dw 3            ; fill                   
            dw 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0      ;  32 byte
            dw 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0      ;  32 byte
            dw 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0      ;  32 byte
            dw 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0      ;  32 byte
                                                    ; 128 bytes buffer
titl:       db 'Program-Manager',0
errini:     db 'Cannot open '
inifile:    db 'progman.ini',0
icon:       db 0    ; TODO: Need an icon
