CPU 286
ORG -3

%include "const.inc"

    db '->'     ; Begin
    db 0        ; Flags

;-------------------------------------------------

        mov ax, cs
        mov ds, ax
        mov [storcs], ax
        mov [storcs2], ax

        mov ax, 26h
        int 0F0h
        mov [myself], bx

        mov ax, 1016h       ; Create window
        mov si, wndstruct
        int 0F0h
        mov [wnd], ax

        mov ax, 1010h       ; Load DIB to DDB
        mov si, einbild
        xor bx, bx          ; isn't sooo large - dont use swap (faster)
        int 0F0h
        mov ax, es
        or ax, ax
        jnz ddbld

        mov ax, 38h         ; ok-msgbox
        mov si, errdib
        int 0F0h

        xor ax, ax
        int 0F0h

ddbld:    
        mov ax, 2015h       ; create a ddb-image
        mov dx, [wnd]
        xor bx, bx
        mov cx, 1
        int 0F0h

        mov ax, 100bh       ; dib_load
        mov si, zweibild
        mov bx, NEWDIB_TRY_SWAP ; NEWDIB_TRY_LOCALMEM
        int 0F0h
        mov [keypressdib], ax

        mov ax, 2012h       ; create radio button
        mov bx, 10
        mov cx, 50
        mov si, 1
        xor di, di
        int 0F0h
        mov [vierteams], ax

        mov ax, 2012h       ; create radio button
        mov bx, 160
        xor si, si
        xor di, di
        int 0F0h
        mov [zweiteams], ax

        xor ax, ax
        mov es, ax
        mov ax, 2004h       ; create a label
        mov bx, 25
        mov cx, 53
        xor di, di
        mov si, vierzweier
        int 0F0h

        mov ax, 2004h       ; create a label
        mov bx, 175
        xor di, di
        mov si, zweivierer
        int 0F0h

        mov ax, 30h         ; create stringlist
        mov cx, 8           ; allocby
        int 0F0h
        mov ax, es
        mov [mainlist], ax

        mov ax, 42h         ; add seperated items
        mov si, leute
        mov bl, ','
        int 0F0h

        mov ax, 2009h       ; create listbox
        mov dx, [wnd]
        mov bx, 10
        mov cx, 65
        mov si, 110
        mov di, 170
        int 0F0h

        mov ax, 30h         ; create another stringlist
        mov cx, 32          ; allocby
        int 0F0h
        mov ax, es
        mov [sublist], ax

        mov ax, 2009h       ; create another listbox
        mov dx, [wnd]
        mov bx, 200
        mov cx, 65
        mov si, 310
        mov di, 170
        int 0F0h
        mov [sublistbox], ax

        mov ax, 2002h       ; create simplebutton
        mov bx, 127
        mov cx, 110
        mov si, createbtn
        mov di, 1
        int 0F0h
        mov [mkbtn], ax

        mov ax, 2002h       ; create simplebutton
        mov bx, 127
        mov cx, 155
        mov si, closebtn
        xor di, di
        int 0F0h
        mov [cbtn], ax

    ; -------------------------------------------------------------
    ; --------------------- MAIN MESSAGE LOOP ---------------------
    ; -------------------------------------------------------------
gmloop:
        mov ax, 10h         ; Getmessage
        int 0F0h
        mov ax, 2000h       ; Dispatchmessage
        int 0F0h
        cmp dx, MSG_CLICK
        jnz gmloop

        cmp si, [wnd]       ; not the wnd
        jnz gmloop

            ; Process clicks
        cmp di, [vierteams]
        jz dovierteams
        cmp di, [zweiteams]
        jz dozweiteams
        cmp di, [mkbtn]
        jz mixit
        cmp di, [cbtn]
        jnz gmloop

        xor ax, ax
        int 0F0h

dovierteams:
        call clearsublist
        mov BYTE [numteam], 4
        jmp gmloop

dozweiteams:
        call clearsublist
        mov BYTE [numteam], 2
        jmp gmloop

mixit:
        call clearsublist

        mov ax, [sublist]
        mov es, ax
        xor di, di
        mov ax, 42h         ; add sperated items
        mov si, leute
        mov bl, ','
        int 0F0h

        mov ax, 22h         ; set adv. message-status
        mov bx, MS_WANTKEYBMSG
        int 0F0h

drawthemixdib:
        mov ax, 101ch       ; draw dib
        mov dx, [wnd]
        xor bx,bx
        xor cx, cx
        mov si, [keypressdib]
        int 0F0h
waitkeygetmsg:
        mov ax, 10h         ; Getmessage
        int 0F0h
            ; This time we don't dispatch the messages
            ; GUI elements are temporary dead
        cmp dx, MSG_PAINT
        jz drawthemixdib
        cmp dx, MSG_GENERICKEYB
        jnz waitkeygetmsg
            ; a key is pressed - check it
        cmp si, KB_ASCII
        jnz waitkeygetmsg      ; not an ascii? ignore.
        mov ax, di

        cmp al, 13          ; enter key
        jz mixingend
        cmp al, '0'
        jbe waitkeygetmsg
        cmp al, '9'
        jnb waitkeygetmsg

        sub al, '1'
        mov cx, ax
        mov bx, [lastnum]
        cmp bx, 0xFFFF
        jz justset

        mov ax, [sublist]
        mov es, ax
        mov ax, 43h         ; Swap stringlist items
        xor di, di
        int 0F0h

        mov ax, 0xFFFF
        mov [lastnum], ax
        jmp waitkeygetmsg

justset:
        mov [lastnum], cx
        jmp waitkeygetmsg


mixingend:
        mov ax, 22h         ; set adv. message-status
        mov bx, MS_DEFAULT
        int 0F0h
        mov ax, 0dh          ;sendmessage 
        mov bx, 0xFFFF
        mov cx, MSG_PAINT
        mov si, [wnd]
        int 0F0h

        mov ax, [sublist]
        mov es, ax
        xor di, di
        mov ax, 44h         ; additemat

        cmp BYTE [numteam], 4
        jz insert4

        mov cx, 4
        mov si, team2
        int 0F0h
        mov cx, 0
        mov si, team1
        int 0F0h

        jmp gmloop          ; back to the default getmessage-loop

insert4:
        mov cx, 6
        mov si, team4
        int 0F0h
        mov cx, 4
        mov si, team3
        int 0F0h
        mov cx, 2
        mov si, team2
        int 0F0h
        mov cx, 0
        mov si, team1
        int 0F0h

        jmp gmloop          ; back to the default getmessage-loop

clearsublist:
        push es
        mov ax, [sublist]
        xor di, di
        mov es, ax
        mov ax, 36h         ; Clear stringlist
        int 0F0h
        pop es
paintsublist:
        mov ax, 2017h       ; Repaintele
        mov dx, [sublistbox]
        int 0F0h
        ret

    ; fensterstruktur
wndstruct:
myself:     dw 0xFFFF
            dw 32+64+8      ; Flags: WF_TITLE + WF_ICON_SPRITE + WF_FILL
            dw 0,0,0,0      ; x,y,w,h
            dw 0,0          ; wprg
            dw titl         ; title OFF
storcs:     dw 0            ; title SEG
            dw icon
storcs2:    dw 0            ; icon
            dw 9            ; fill
    ; variablen
wnd:            dw 0        ; window
mainlist:       dw 0        ; strlinglist for "leute"
sublist:        dw 0        ; result stringlist
sublistbox:     dw 0        ; result listbox
mkbtn:          dw 0        ; handle for the GO button
vierteams:      dw 0        ; 4 teams radiobutton
zweiteams:      dw 0        ; 2 teams radiobutton
numteam:        db 4        ; number of teams (opt.btn selected)
keypressdib:    dw 0        ; dib displayed when randomizing
lastnum:        dw 0xFFFF   ; last number entered
cbtn:           dw 0        ; handle for the close btn
    ; strings
titl:       db 'AOE TeamGen',0
errdib:     db 'Fehler beim laden der DIB: '
einbild:    db 'aoeteam.spm',0
zweibild:   db 'aoeteam2.spm',0
createbtn:  db '> GO >',0
vierzweier: db 'Vier Teams',0
zweivierer: db 'Zwei Teams',0
closebtn:   db 'Ende',0
team1:      db '   Team 1:',0
team2:      db '   Team 2:',0
team3:      db '   Team 3:',0
team4:      db '   Team 4:',0
leute:      db 'Emanuel,Eva,Fabian,Lisa,Marita,Oliver,Simon,Stefan',0
icon:
    db 10
    db ' AB   E',10
    db '      F',10
    db 10
    db '     C  ',10
    db ' IJ  D',0
