     
// A=0, H=7, I=8, P=15

char optbtn[] =  "    IIII  \n  IIAAAAII\n IAAPPPPAAP\n IAPPPPPPHP\nIAPPPPPPPPHP\nIAPPPPPPPPHP\nIAPPPPPPPPHP\nIAPPPPPPPPHP\n IAPPPPPPHP\n IHHPPPPHHP\n  PPHHHHPP\n    PPPP";
char optbtnl[] =  "    IIII  \n  IIAAAAII\n IAAHHHHAAP\n IAHHHHHHHP\nIAHHHHHHHHHP\nIAHHHHHHHHHP\nIAHHHHHHHHHP\nIAHHHHHHHHHP\n IAHHHHHHHP\n IHHHHHHHHP\n  PPHHHHPP\n    PPPP";
char chker[] =   "      A\n     AA\nA   AAA\nAA AAA\nAAAAA\n AAA\n  A";
char knoedel[] = " AA\nAAAA\nAAAA\n AA";
char arrleft[] = "   A\n  AA\n AAA\nAAAA\n AAA\n  AA\n   A";
char arrright[] = "A   \nAA\nAAA\nAAAA\nAAA\nAA\nA";
char arrup[] = "   A\n  AAA\n AAAAA\nAAAAAAA";
char arrdown[] = "AAAAAAA\n AAAAA\n  AAA\n   A";


void wm_drawbutton(UINT wnd, int x1, int y1, int x2, int y2, UINT fillcol)
    {
        // Outer
    wm_hline(wnd,x1,y1,x2, 15);
    wm_vline(wnd,y1,x1,y2, 15);
    wm_hline(wnd,x1,y2,x2, 0);
    wm_vline(wnd,y1,x2,y2, 0);
        // Middle
    x1++, y1++, x2--, y2--;
    wm_hline(wnd,x1,y1,x2, 7);
    wm_vline(wnd,y1,x1,y2, 7);
    wm_hline(wnd,x1,y2,x2, 8);
    wm_vline(wnd,y1,x2,y2, 8);
        // Inner
    x1++, y1++, x2--, y2--;
    if(fillcol != 0xFFF) wm_rectf(wnd,x1,y1,x2,y2,fillcol);
    }

void wm_drawbuttondown(UINT wnd, int x1, int y1, int x2, int y2, UINT fillcol)
    {
        // Outer
    wm_hline(wnd,x1,y1,x2, 8);
    wm_vline(wnd,y1,x1,y2, 8);
    wm_hline(wnd,x1,y2,x2, 15);
    wm_vline(wnd,y1,x2,y2, 15);
        // Middle
    x1++, y1++, x2--, y2--;
    wm_hline(wnd,x1,y1,x2, 0);
    wm_vline(wnd,y1,x1,y2, 0);
    wm_hline(wnd,x1+1,y2,x2, 7);
    wm_vline(wnd,y1+1,x2,y2, 7);
        // Inner
    x1++, y1++, x2--, y2--;
    if(fillcol != 0xFFF) wm_rectf(wnd,x1,y1,x2,y2,fillcol);
    }

void wm_drawoptbtn(UINT wnd, int x, int y, UCHR checked, UCHR lstate)
    {
    wm_drawsprite(wnd,x,y,lstate ? optbtnl : optbtn);
    if(checked)
        wm_drawsprite(wnd,x+4,y+4,knoedel);
    }

void wm_drawcheckbox(UINT wnd, int x, int y, UCHR checked, UCHR lstate)
    {
    wm_drawbuttondown(wnd,x,y,x+13,y+13,(lstate == 1) ? 7 : 15);
    if(checked)
        wm_drawsprite(wnd,x+3,y+3,chker);
    }

void wm_fillbtnwithtext(UINT wnd, int x1, int y1, int x2, int y2, UINT fntid, UINT fgcol, char *text)
    {
    wm_outtext(wnd,((x2 - x1) / 2 - textwidth(fntid, text) / 2) + x1, ((y2 - y1) / 2 - textheight(fntid, text) / 2) + y1, fgcol, 0xFFF, fntid, text);
    }

void wm_drawcompletebutton(UINT wnd, int x1, int y1, int x2, int y2, UCHR down, int fntid, UINT fgcol, UINT bgcol, char *text)
    {
    down = !!down;
    if(down)
        wm_drawbuttondown(wnd,x1,y1,x2,y2,bgcol);
    else
        wm_drawbutton(wnd,x1,y1,x2,y2,bgcol);
    wm_fillbtnwithtext(wnd,x1+down*2,y1+down*2,x2,y2,fntid,fgcol,text);
    }

void wm_drawscrollbase(UINT wnd, int x1, int y1, int x2, int y2, int ishoriz)
    {
//    printf("wm_drawscrollbase(%i,%i,%i,%i,%i,%i)\n",wnd,x1,y1,x2,y2,ishoriz);
    wm_rect(wnd,x1,y1,x2,y2,8);
    x1++,y1++,x2--,y2--;
    wm_rectf(wnd,x1,y1,x2,y2,7);
    if(ishoriz)
        {
        wm_vline(wnd,y1,x1 + 8,y2,8);
        wm_vline(wnd,y1,x2 - 8,y2,8);
        wm_drawsprite(wnd,x1+1,y1+1,arrleft);
        wm_drawsprite(wnd,x2-5,y1+1,arrright);
        }
    else
        {
        wm_hline(wnd,x1,y1 + 8,x2,8);
        wm_hline(wnd,x1,y2 - 8,x2,8);
        wm_drawsprite(wnd,x1+1,y1+2,arrup);
        wm_drawsprite(wnd,x1+1,y2-5,arrdown);
        }
    }

